<template>
    <div class="problems-panel" :class="{'problems-panel--show': is_shown}">
        <div class="problems-panel__item" :ref="`card-${problem.id}`" v-for="problem in problems" :key="problem.id" @click="changeActiveCard(problem.id)" :class="{'problems-panel__item--active': cardIsActive(problem.id)}">
            <div class="problems-panel__item__value" :class="[`problems-panel__item__value--${problem.color}`]">{{ problem.value }}</div>
            <div class="problems-panel__item__title">{{ problem.tip.title }}</div>
            <div class="problems-panel__item__text">{{ problem.tip.text }}</div>
            <div class="problems-panel__item__suggest" v-if="problem.tip.suggest">
                <div class="problems-panel__item__suggest__title">Options:</div>
                <button class="button-link problems-panel__item__suggest__item" v-for="(suggest, i) in problem.tip.suggest" :key="i">{{ suggest }}</button>
            </div>
        </div>
    </div>
</template>

<script>
export default {
    props: ['problems'],
    data() {
        return {
            is_shown: false
        }
    },

    computed: {
        activeCardId() {
            return this.$store.state.parts.active;
        }
    },

    methods: {
        show() {
            this.is_shown = true;
            try {
                let offset = this.$refs[`card-${this.activeCardId}`][0].offsetTop - 30;
                this.$el.scrollTop = offset;
            } catch (error) {
                
            }
        },

        hide() {
            this.is_shown = false;
        },

        toggle() {
            this.is_shown = !this.is_shown;
        },

        cardIsActive(id) {
            return this.activeCardId == id;
        },

        changeActiveCard(id) {
            this.$store.commit('parts/set', id);
        }
    },

    created() {
        this.$root.$refs['problems-panel'] = this;
    }
}
</script>

<style lang="scss">
.problems-panel {
    position: fixed;
    right: 0;
    top: 0;
    bottom: 0;
    width: 400px;
    background-color: #fff;
    z-index: 1002;
    padding: 30px;
    transform: translateX(110%);
    box-shadow: -10px 0px 20px rgba(0,0,0,.05);
    transition: transform .4s ease;
    overflow: auto;
    scroll-behavior: smooth;
    &--show {
        transform: translateX(0);
    }
}

.problems-panel__item {
    border: 1px solid #eee;
    z-index: 100;
    padding: 20px 20px 25px;
    border-radius: 8px;
    cursor: pointer;
    margin-bottom: 15px;

    &--active {
        border-color: orange;
        background-color: rgba(orange, .05);
    }

    &__value {
        font-weight: 400;
        font-size: 18px;
        z-index: 101;
        margin-bottom: 15px;
        font-style: italic;
    }

    &__title {
        font-weight: 600;
    }
    &__text {
        font-size: 13px;
        line-height: 145%;
        margin-top: 5px;
        color: #666;
        z-index: 101;
    }

    &__suggest {
        border-top: 1px solid #eee;
        margin-top: 15px;
        padding-top: 10px;
        &__title {
            font-weight: 600;
            margin-bottom: 8px;
            font-size: 12px;
        }
        &__item {
            border-radius: 100px;
            border: 1px solid #0b8f59 !important;
            color: #0b8f59;
            padding: 5px 10px;
            background-color: #fff;
            margin-right: 5px;
            &:hover {
                background-color: rgba(#0b8f59, .1);
                
            }
        }
    }
}
</style>